// Code generated by "enumer -type=Ranks -json -text -yaml -sql"; DO NOT EDIT.

//
package ranks

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _RanksName = "ClassOneClassTwoClassThreeClassFourClassFiveOrdinaryDay"

var _RanksIndex = [...]uint8{0, 8, 16, 26, 35, 44, 55}

func (i Ranks) String() string {
	if i < 0 || i >= Ranks(len(_RanksIndex)-1) {
		return fmt.Sprintf("Ranks(%d)", i)
	}
	return _RanksName[_RanksIndex[i]:_RanksIndex[i+1]]
}

var _RanksValues = []Ranks{0, 1, 2, 3, 4, 5}

var _RanksNameToValueMap = map[string]Ranks{
	_RanksName[0:8]:   0,
	_RanksName[8:16]:  1,
	_RanksName[16:26]: 2,
	_RanksName[26:35]: 3,
	_RanksName[35:44]: 4,
	_RanksName[44:55]: 5,
}

// RanksString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func RanksString(s string) (Ranks, error) {
	if val, ok := _RanksNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to Ranks values", s)
}

// RanksValues returns all values of the enum
func RanksValues() []Ranks {
	return _RanksValues
}

// IsARanks returns "true" if the value is listed in the enum definition. "false" otherwise
func (i Ranks) IsARanks() bool {
	for _, v := range _RanksValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for Ranks
func (i Ranks) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for Ranks
func (i *Ranks) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("Ranks should be a string, got %s", data)
	}

	var err error
	*i, err = RanksString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for Ranks
func (i Ranks) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for Ranks
func (i *Ranks) UnmarshalText(text []byte) error {
	var err error
	*i, err = RanksString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for Ranks
func (i Ranks) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for Ranks
func (i *Ranks) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = RanksString(s)
	return err
}

func (i Ranks) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *Ranks) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := RanksString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
